# Vertical Scrolling Browser

Required Class Files: vsb.class, occcolor.class, ocfontc.class, vsbread.class, ocekey.class Notice Tag: "Vertical Scrolling Browser, (c) 1997, OpenCube Technologies, Registered (Unique Key ID#)"

Online Documentation at www.opencube.com

The online documentation includes general information regarding the use of the applet tag and uploading applets to the server, common Java bugs with Internet Explorer and Netscape as well as an applet configuration FAQ.

- Applet Configuration FAQ
- Technical Document Index

Information about the applet and its parameters

Required Parameters

Parameter 1 (the "notice" tag) must be included in the applet tag in order for the applet to work. Most of the parameters will default if you fail to define them, at a minimum you must include the notice tag and and a file location tag pointing to your first scrolling file. Usually the easiest way to customize the applet is to cut and paste the applet tag information used in the sample and modify it to fit your web page.

Defining Colors

This applet uses a simple RGB or Hexadecimal color definition scheme. On most systems (depending on the software being used to choose a color) its easier to define a color using RGB, however since most web pages define colors using a HEX value we have allowed for both methods of color definition. To define a color using RGB use commas to separate the values such as 255,255,255 (White). To define a color using a hexadecimal value use a pound sign ('#') followed by a 6 digit hex value in the rage of 000000 - FFFFFF (e.g. #FFFFFF is equal to the color White).

Color Definition with RGB: To define a color in one of the color parameters using RGB choose a value between 0 - 255 for the red, green, and blue components separated by commas and typed out in the correct r,g,b order. Below is a sample of how a color parameter using RGB should look, the example specifies several different sample colors for the "bgcolor" parameter.

WHITE: <param name="bgcolor" value="255,255,255">
GREEN: <param name="bgcolor" value="0,255,0">
BLACK: <param name="bgcolor" value="0,0,0">
YELLOW: <param name="bgcolor" value="255,255,0">
OFF WHITE: <param name="bgcolor" value="240,239,234">

The best way to choose the exact color you are looking for without having to guess the numbers is to access your systems Color Picker. Color Pickers usually allow you to drag the mouse over a rainbow type color grid to select a color, and show you the appropriate RGB values. In windows the Color Picker is accessible through MS Paint as well as a majority of the popular Imaging and HTML Authoring Software.

Creating the Text Files

This applet uses simple text files in order to define each scrolling message, message attributes, sizing, URL links, colors, pause delay times, etc. Below are links to the four pages used in the example above... Only one text file is required, however the sample above uses four files and takes advantage of the applets browsing feature which allows you to define links to other scrolling message files within the applet.

- Home.txt

- Key.txt

- Customize.txt

- Usage.txt

Each line in the text file represents a customizable section of the scrolling message. Text that is longer than the applet width is automatically put in a multi line format and will be multi-line highlighted if an associated URL and highlight color are defined. Each line must be specified with a series of values identifying the size pause, delay time, font, alignment, text color, load URL where, URL, and message. Each value must be separated by a vertical bar ("|" AKA: pipe symbol). Below is an example of how a line in the file defining a message should look.

size pause|delay time| font setting|alignment|text color|load URL where|URL|message.

To specify a section of the scroll message using the default values defined using the parameters just use the message text without any pipe symbols for that line. If defining some properties but not all make shore to includes all the pipe symbols and leave the attributes using the defaults blank. To create a blank space to separate paragraphs use a regular blank line or seven pipes with a space character at the end.

Size Pause|
Attribute: Automatically Size the Starting Position of the Following Message
Value=0 or 1 or 2: 0 = do nothing, this is the default value, 1 = Identifies a message as the starting message to be automatically sized to fit the applet height, 2 = Identifies the ending message to be sized. To automatically size messages that span multiple description tags, simply set the starting message to 1 and the ending message to 2 with this parameter. For example if you wanted your second and and third lines in the text file to automatically fit the applet height and your fourth line to become visible only after the second line started off the screen you would simply identify the desc2 as a start sizing message by setting "Size Pause|" = 1 and define the third line as the end sizing message with "sizepause|" = 2. To size only one message to fit the applet height only identify that message as a ending message and do not define a starting message (e.g. "sizepause|" = 2, forces the second message to scroll all the way to the top of the applet before line three becomes visible at the bottom of the applet.)

Delay Time|
Attribute: Message Line Font Name
value="X", Where X is the amount of time in milliseconds to pause the message for. A value of 1000 is equal to 1 second.

Font|
Attribute: Message Line Font Setting
Value = Font Face, Style, Size, Each value must be separated by a comma and appear in the correct order (font face, style, and size) The Allowable Java font face values are Helvetica, TimesRoman, Courier, Dialog, or DialogInput. The allowable style options are plain, bold, bolditalic, or italic.

Alignment|
Attribute: Message Line Alignment
value= left,center, or right

Text Color|
Attribute: Message Line Text Color
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: BLACK

URL Where|
Attribute: Load Destination URL Link Where? (Frame Targeting)
The "loadwhere" tag specifies where the document specified in the "URL" value should be loaded. The default is "_self". A value equal to the name (case sensitive) of a frame will load the document in that frame. Setting this value to applet forces the document to load within the applet itself
"applet" show in the applet
"_self" show in the current frame
"_blank" show in a new unnamed top-level window
"name" show in a new top-level window named name
"frame name" show in the frame named frame name

Note: When targeting a frame location with the name of the frame make certain that the case and names are typed identically. If the applet cannot find the frame the document will be loaded in a new window.

URL|
Attribute: Destination URL Link
Value = X, Where X is the location of the document to load relative to the location of the HTML document containing the applet (e.g. if the HTML page containing the applet is located at http://www.opencube.com and the document to load is located at http://www.opencube.com/myhtml/mydoc.htm then the URL value would be "myhtml/mydoc.htm").

Message
Attribute: The message to be displayed
Note: Specific messages must be contained on one line, using a line break, and starting long messages on the next lines of the text file will cause those lines to inherit the default values set using the parameters. Messages longer than the width of the applet are automatically put in a multi-line format.

The Applet Parameters

The Applet

Parameter 1
Attribute: Copyright notice.
param name="Notice"
value="Vertical Scrolling Browser, (c) 1997, OpenCube Technologies, Unregistered"
Note: This must be included for the applet to work. In order for the applet to recognize the tag the notice must appear as a continuous line of text without any line breaks and the words must be capitalized correctly.

Parameter 2
Attribute: Background Color
param name= "bgcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: WHITE

Parameter 3
Attribute: Message Scroll Delay
param name = "scrolldelay"
value="X", where X is the delay time in milliseconds between animation frames. See the browser bug page on the OpenCube site at http://www.opencube.com/doc_bb.htm for information regarding delay time issues.
DEFAULT: 25

Parameter 4
Attribute: Message Scroll Jump
param name = "scrolljump"
value="X", where X is the distance in screen pixels to jump between frames. Note: The minimum value is one. The higher the value the faster the animation will run and the choppier the effect. Message pausing is not allowed with values larger than one.
DEFAULT: 1

Parameter 5
Attribute: Default Status Bar Text when mouse is over applet
param name = "onsbtext"
value="X", where X is the message to appear in the status bar when the mouse is over the applet but not over a URL link.
DEFAULT: "OpenCube - Vertical Scrolling Browser"

Parameter 6
Attribute: Default Status Bar Text when mouse is off applet
param name = "offsbtext"
value="X", where X is the message to appear in the status bar when the mouse is not over the applet.
DEFAULT: "Java By OpenCube"

The File Attributes

Parameter 7
Attribute: Initial File Location
param name = "filelocation"
value="X", Where X is the relative location and name of the initial file to load. The file must be specified relative to the document containing the applet. Note: All subsequent applet loading page references must also be defined relative to the document containing the applet.

Parameter 8
Attribute: Status Bar Text when Refreshing the Scrolling Document
param name = "sbupdatetext"
value="X", Where X is the message to be show in the status bar while the current scroll document is being refreshed.
DEFAULT: "Updating Scroll Data..."

Parameter 9
Attribute: Document Refresh Scroll Interval
param name = "refreshinterval"
value="X", Where X is the scroll interval on which to refresh the current document. A value of one forces the current scroll file to be refreshed at the end of every scroll cycle, a value of two forces the refresh every other scroll cycle, etc.
DEFAULT: 1

Parameter 10
Attribute: Wait for refreshed files to load before scrolling the document
param name = "waitforfile"
value= true or false, Where true = yes, wait for the refreshed file to completely load before the document is scrolled. Note: a value of true will force the applet to pause (if a scroll cycle is defined) between scroll cycles while the refreshed document is loading, using a value of true with a refresh interval of 1 forces the applet to updates its data after every scroll cycle. False = no, continue to scroll the document while loading the updated file. False does not force the applet to pause between scroll cycles and updates the data from the file while scrolling (achieved from a separate thread for consistent scrolling), however the applet must scroll twice before the initial update is achieved, all subsequent updates happen on every scroll. The basic procedure when false is to get the updated document, while scrolling the previous document, then at the end of the scroll cycle show the document fetched while retrieving the next update, etc., etc.
DEFAULT: false

Parameter 11
Attribute: Scroll After a URL Link is Clicked
param name = "scrollafterlink"
value=true or false, Where true = yes, when linking to a new page continue to scroll the message. False = no, when opening a new page stop the document from scrolling.
DEFAULT: false

Parameter 12
Attribute: Use an Overlap Transition when Loading New Pages in the Applet
param name = "overlaplocalload"
value=true or false, Where true = yes, use an overlap transition effect when loading the next document. False = no first clear the screen then start the next document scrolling.
DEFAULT: true

The Scrolling Messages Default Attributes

Parameter 13
Attribute: Default Text Color
param name= "textcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: BLACK

Parameter 11
Attribute: Font
param name = "font"
Value = Font Face, Style, Size, Each value must be separated by a comma and appear in the correct order (font face, style, and size) The Allowable Java font face values are Helvetica, TimesRoman, Courier, Dialog, or DialogInput. The allowable style options are plain, bold, bolditalic, or italic.
DEFAULT: Dialog, plain, 12

Parameter 17
Attribute: Default Text Alignment
param name="alignment"
Value = left, center, or right

Parameter 18
Attribute: Left and Right Margin Width
param name="lrmargins"
Value = X, Where X is the width of the right and left margins.

URL Link Properties

Parameter 19
Attribute: Default Load Destination URLs Where?
param name = "loadwhere"
The "loadwhere" tag specifies where the document specified in the "URL" value should be loaded. The default is "_self". A value equal to the name (case sensitive) of a frame will load the document in that frame. Setting this value to applet forces the document to load within the applet itself
"applet" show in the applet
"_parent" show in the parent frame
"_top" show in the top-most frame
"_self" show in the current frame
"_blank" show in a new unnamed top-level window
"name" show in a new top-level window named name
"frame name" show in the frame named frame name

Note: When targeting a frame location with the name of the frame make certain that the case and names are typed identically. If the applet cannot find the frame the document will be loaded in a new window.

Parameter 20
Attribute: URL Link Highlight Color
param name="hlcolor"
Value=r,g,b or #000000 - #FFFFFF - See above for more information on defining colors.
DEFAULT: Yellow

Vertical Scrolling Browser, © 1997, OpenCube Technologies